package no.integration.svv.utils.validator;

import no.geointegrasjon.rep.arkiv.oppdatering.xml_wsdl._2012_01.NyDokument;
import no.geointegrasjon.rep.arkiv.oppdatering.xml_wsdl._2012_01.NyJournalpost;
import no.geointegrasjon.rep.arkiv.oppdatering.xml_wsdl._2012_01.NySaksmappe;
import no.geointegrasjon.rep.arkiv.oppdatering.xml_wsdl._2012_01.OppdaterJournalpostStatus;
import no.integration.svv.exception.ValidationException;

public class RequestValidator {

    public static final String NY_JOURNALPOST_ENDPOINT = "NyJournalpost";
    public static final String NY_SAKSMAPPE_ENDPOINT = "NySaksmappe";
    public static final String NY_DOKUMENT_ENDPOINT = "NyDokument";
    public static final String NY_JPSTATUS_ENDPOINT = "OppdaterJournalpostStatus";


    public static void validateJournalpostRequest(NyJournalpost request) throws ValidationException {
        if (request == null) {
            throw new ValidationException(NY_JOURNALPOST_ENDPOINT, "Body", "Missing value");

        }
        if (request.getJournalpost() == null) {
            throw new ValidationException(NY_JOURNALPOST_ENDPOINT, "getJournalpost", "Missing value");

        }

        if (request.getJournalpost().getKorrespondansepart() == null || request.getJournalpost().getKorrespondansepart().getListe().size() == 0) {

            throw new ValidationException(NY_JOURNALPOST_ENDPOINT, "getKorrespondansepart", "Missing value");
        }
        if (request.getJournalpost().getKorrespondansepart().getListe().get(0).getKorrespondanseparttype() == null) {

            throw new ValidationException(NY_JOURNALPOST_ENDPOINT, "getKorrespondanseparttype", "Missing value");
        }

    }

    //ToDO: Check for the required fields to validate
    public static void validateNySaksmappeRequest(NySaksmappe request) throws ValidationException {
        if (request == null) {
            throw new ValidationException(NY_SAKSMAPPE_ENDPOINT, "Body", "Missing value");
        }
        if (request.getMappe() == null) {
            throw new ValidationException(NY_SAKSMAPPE_ENDPOINT, "getMappe", "Missing value");
        }
    }

    public static void validateNyDokumentRequest(NyDokument request) throws ValidationException {

        if (request == null) {
            throw new ValidationException(NY_DOKUMENT_ENDPOINT, "Body", "Missing value");

        }
        if (request.getDokument() == null) {
            throw new ValidationException(NY_DOKUMENT_ENDPOINT, "getDokument", "Missing value");

        }
        if (request.getDokument().getFil() == null) {
            throw new ValidationException(NY_DOKUMENT_ENDPOINT, "getFil", "Missing value");

        }
    }

    public static void validateJPStatusRequest(OppdaterJournalpostStatus request) throws ValidationException {

        if (request == null) {
            throw new ValidationException(NY_JPSTATUS_ENDPOINT, "Body", "Missing value");

        }
        if (request.getJournalstatus() == null) {
            throw new ValidationException(NY_JPSTATUS_ENDPOINT, "getJournalstatus", "Missing value");

        }
    }


}
